{$mode objfpc}{$R-}{$H+}{$assertions on}
uses
  Math;
type TElem = record
  cnt: Integer;
  next: array ['0'..'1'] of Integer;
end;
var
  L, treeSize, i, M: Integer;
  s: String;
  tree: array of TElem;
  path: array of Integer;

  function Find(start: Integer): Integer;
  var
    p: Integer;

    procedure M(var r: Integer); inline;
    begin
      if r = 0 then begin
        treeSize += 1;
        r := treeSize;
      end;
      p := r;
    end;

  var
    j: Integer;
  begin
    p := 0;
    for j := 0 to L - 1 do begin
      path[j] := p;
      M(tree[p].next[s[start + j]]);
    end;
    Result := p;
  end;

  function CntDef(a: Integer): Integer; inline;
  begin
    if a = 0 then Result := 0 else Result := tree[a].cnt;
  end;

  procedure Update;
  var
    j: Integer;
  begin
    for j := L - 1 downto 0 do
      with tree[path[j]] do
        cnt := Max(CntDef(next['0']), CntDef(next['1']));
  end;

var
  j : Integer;
begin
  AssignFile(input, 'input.txt'); Reset(input);
  AssignFile(output, 'output.txt'); Rewrite(output);
  Readln(L, M);
  Readln(s);
  Assert((1 <= M) and (L <= M) and (M <= Length(s)) and (1 <= L));
  SetLength(tree, Length(s) * L + 1);
  treeSize := 0;
  SetLength(path, L);
  for i := 1 to Length(s) - L + 1 do begin
    if i + L - 1 > M then begin
      j := Find(i + L - 1 - M);
      if tree[j].cnt = 0 then begin Write('!!!'); Halt(99); end;
      tree[j].cnt -= 1;
      Update;
    end;
    tree[Find(i)].cnt += 1;
    Update;
    if i + L > M then
      Write(tree[0].cnt, ' ');
  end;
end.
